<?php
/**
 * @package Sj Suggeted Posts for Kunena
 * @version 2.5.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2013 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */
 
 defined ( '_JEXEC' ) or die ( '' );
	
	// ini_set('display_errors', 'on');
	// ini_set('error_reporting', E_ALL );
	
if(!class_exists('SuggestedPostsHelper')){
	class SuggestedPostsHelper{
		protected static $helper = null;
		public static $sug_total = 0;
		protected static $_instances = array();
		public static function getList( $params, $module){
			$helper =  self::getInstance();
			return $helper->_getList( $params, $module );
		}
		
		protected function _getList( $params, $module ){
			$list = array();
			KunenaFactory::loadLanguage('com_kunena.controllers');
			KunenaFactory::loadLanguage('com_kunena.models');
			KunenaFactory::loadLanguage('com_kunena.views');
			KunenaFactory::loadLanguage('com_kunena.templates');
			KunenaFactory::loadLanguage('com_kunena.sys', 'admin');
			// Load last to get deprecated language files to work
			KunenaFactory::loadLanguage('com_kunena');
			KunenaForum::setup();
			// Convert module parameters into topics view parameters
			$categories = $params->get ( 'category_id', false );
			$limit = $params->get ( 'nbpost',5 );
			$search_filter = $params->get('search_filter',1);
			$orderby = $params->get('orderby',1);
			$_params = array( 'orderby'=>$orderby,'search_filter'=>$search_filter );
				
			$is_ajax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
			
			if($is_ajax){
				list($total, $messages) = self::_getData($categories, 0, $limit, $_params);
				self::$sug_total = $total;
				foreach ($messages as $message) {
					$row = new StdClass();
					$row = $message;
				//	$row->index = 0;
					$row->id = $message->id;
					$row->link_topic = $message->getUrl();
					$row->catname = $message->getCategory()->name;
					$row->link_cat = $message->getCategory()->getUrl();
					//$row->topic = $message->getTopic();
					$row->avatar =  KunenaFactory::getUser($message->userid)->getAvatarImage('', '');
					$row->link_user =$message->getAuthor($message->userid)->getUrl();
					$row->topic_icon = $message->getTopic()->getIcon();
					$list[] = $row;
				}
					//var_dump($list);
			return $list;
			}
		}
		
		public static function _getData($categories=false, $limitstart=0, $limit=0, $params=array()) {
			$reverse = isset($params['reverse']) ? (int) $params['reverse'] : 0;
			$orderby = isset($params['orderby']) ? (int) $params['orderby'] : 1;
			$starttime = isset($params['starttime']) ? (int) $params['starttime'] :0;
			$mode = isset($params['mode']) ? $params['mode'] : 'recent';
			$user = isset($params['user']) ? $params['user'] : false;
			$where = isset($params['where']) ? (string) $params['where'] : '';
			$childforums = isset($params['childforums']) ? (bool) $params['childforums'] : false;
			$search_filter = isset($params['search_filter'])? (int) $params['search_filter'] : 0;
			$search = '';
			$order = '';
			if(isset($_POST) &&  isset($_POST['suggestion_key']) && !empty($_POST['suggestion_key']) ){
				$search_subj = self::_getConditions($_POST['suggestion_key'],'m.subject');
				$search_message = self::_getConditions($_POST['suggestion_key'],'t.message');
				$search = "  ( ".(string)$search_subj." OR ".(string)$search_message.") "; 
				$ordersubject = self::_getConditions($_POST['suggestion_key'],'order.subject');
				$ordermessage = self::_getConditions($_POST['suggestion_key'],'order.message');
				$order = $ordersubject.$ordermessage;
				$order = "  CASE ". $order ." END, m.subject ";
			}
			
			$db = JFactory::getDBO();
			// FIXME: use right config setting
			if ($limit < 1 && empty($params['nolimit'])) $limit = KunenaFactory::getConfig ()->threads_per_page;

			$cquery = new KunenaDatabaseQuery();
			$cquery->select('COUNT(*)')
				->from('#__kunena_messages AS m')
				->innerJoin('#__kunena_messages_text AS t ON m.id = t.mesid')
				->where('m.moved=0'); // TODO: remove column

			$rquery = new KunenaDatabaseQuery();
			$rquery->select('m.*, t.message')
				->from('#__kunena_messages AS m')
				->innerJoin('#__kunena_messages_text AS t ON m.id = t.mesid')
				->where('m.moved=0')
				->group('m.id');// TODO: remove column
			$authorise = 'read';
			$hold = 'm.hold=0';
			$userfield = 'm.userid';
			if (is_array($categories) && in_array(0, $categories)) {
				$categories = false;
			}
			$categories = KunenaForumCategoryHelper::getCategories($categories, $reverse, 'topic.'.$authorise);
			if ($childforums) {
				$categories += KunenaForumCategoryHelper::getChildren($categories, -1, false, array('action'=>'topic.'.$authorise));
			}
			$catlist = array();
			foreach ($categories as $category) {
				$catlist += $category->getChannels();
			}
			if (empty($catlist)) return array(0, array());
			$allowed = implode(',', array_keys($catlist));
			if($search_filter){
				$cquery->where("m.catid IN ({$allowed}) ");
				$rquery->where("m.catid IN ({$allowed}) ");
			}else{
				$cquery->where("m.catid IN ({$allowed}) ");
				$rquery->where("m.catid IN ({$allowed}) ");
				$cquery->where("m.parent = 0");
				$rquery->where("m.parent = 0");
			
			}	

			$cquery->where($hold);
			$rquery->where($hold);
			if ($user) {
				$cquery->where("{$userfield}={$db->Quote($user)}");
				$rquery->where("{$userfield}={$db->Quote($user)}");
			}
			// Negative time means no time
			if ($where) {
				$cquery->where($where);
				$rquery->where($where);
			}
			
			if($search){
				$cquery->where($search);
				$rquery->where($search);
			}
			
			if($orderby == 3 ){
				$orderby = 'm.time DESC';
				$rquery->order($orderby);
			}else if($orderby == 1 && $order != '' ){
				$orderby = $order;
				$rquery->order($orderby);
			}

			$db->setQuery ( $cquery );
			$total = ( int ) $db->loadResult ();
			if (KunenaError::checkDatabaseError() || !$total) return array(0, array());

			// If out of range, use last page
			$db->setQuery ( $rquery, JRequest::getInt('ajax_suggestion_start',0), $limit );
			
			$results = $db->loadAssocList ();
			if (KunenaError::checkDatabaseError()) return array(0, array());
		//echo $rquery; die;
			$messages = array();
			foreach ( $results as $result ) {
				$instance = new KunenaForumMessage ($result);
				$instance->exists(true);
				self::$_instances [$instance->id] = $instance;
				$messages[$instance->id] = $instance;
			}
			unset ($results);
			
			foreach ($messages as $message) {
				$get_tk = KunenaForumMessageThankyouHelper::get($message->id)->getList();
				$message->count_tk = (!empty($get_tk))?count($get_tk):0;
				$message->posts = $message->getTopic()->posts;
			}
			if($orderby == 0){
				usort($messages, create_function('$a, $b', 'return $a->posts < $b->posts;'));
			}else if($orderby == 2){
				usort($messages, create_function('$a, $b', 'return $a->count_tk < $b->count_tk;'));
			}
			return array($total, $messages);
		}
		
		public static function _processKS($keysearch){
			$words = explode(" ", $keysearch);
			$limit = sizeof($words);
			$list = array();
			for ($start = 0; $start < count($words); $start++) //starting point
			{
			   for ($len = 1; $len <= $limit && $len <= count($words)-$start; $len++)
			   {
				  $list[] = implode(" ", array_slice($words, $start, $len));
			   }
			}
				for($i=0;$i<sizeof($list) - 1;$i++)  {  
					$tg = '';  
					$vtmin=$i;
					for($j=$i+1; $j<sizeof($list); $j++)  
					if (strlen($list[$j])> strlen($list[$vtmin])) 
						$vtmin=$j;  
						if($vtmin!=$i) {  
							$tg=$list[$vtmin];
							$list[$vtmin]=$list[$i]; 
							$list[$i]=$tg; 
						} 
				  }  
				return $list;
		}
		
		public static function highlight($needle, $haystack){
			$keys = self::_processKS($needle);
			$string = explode(" ",$haystack);
			for($j = 0;$j< count($string); $j++){
				for($i = 0; $i<count($keys); $i++){
					if(strtolower($keys[$i]) === strtolower($string[$j])){
						$string[$j] = '<span class="sg-key">'.$string[$j].'</span>';
						
					}else if(stripos($string[$j], $keys[$i]) !== false && stripos($string[$j],'<span class="sg-key">') === false  && stripos($string[$j],'</span>') === false   ) {
						$ind = stripos($string[$j], $keys[$i]);
						$len = strlen($keys[$i]);
						$string[$j] = substr($string[$j], 0, $ind).'<span class="sg-key">' . substr($string[$j], $ind, $len).'</span>'.
						 substr($string[$j],$ind + $len);
					}
				}	
			}
		
			return implode(" ",$string);
		} 
		
		private static function _getConditions ($key_ajax,$value) {
			$a = self::_processKS($key_ajax);
			settype($a, 'array');
			$search_key = array();
			switch($value){
				case 'm.subject':
				case 't.message': 
					for($i=0 ; $i< sizeof($a); $i++){
						if($i < sizeof($a)-1){
							$query[] = " ".$value." LIKE '%". $a[$i] . "%' OR ";
						}else if($i == sizeof($a)-1){
							$query[] = " ".$value." LIKE '%". $a[$i] . "%' ";
								
						}
					}	
					$search_key = implode(" ", $query);
					break;
				case 'order.subject':
				case 'order.message':
						if($value == 'order.subject'){
							$v = 'm.subject';
						}else{
							$v = 't.message';
						}
					$j = sizeof($a)-1;
					for($i=0 ; $i< sizeof($a); $i++){
						$j++;
						if($value == 'order.subject'){
							$query[] = " WHEN ".$v." LIKE '%". $a[$i] . "%' THEN ".$i." ";
						}else{
						 if($i < sizeof($a) -1){
							$query[] = " WHEN ".$v." LIKE '%". $a[$i] . "%' THEN ".$j." ";
						 }else if($i == sizeof($a)-1){
							$query[] = " ELSE ".($j)." ";
						 }
						 }
						   
					}
					$search_key = implode(" ", $query);
					break;	
				default:
					break;
			} 
			return $search_key;
		 }

		public static function _cleanText($text){
			$text = str_replace('<p>', ' ', $text);
			$text = str_replace('</p>', ' ', $text);
			$text = strip_tags($text, '<a><em><strong>');
			$text = trim($text);
			return $text;
		}

		/**
		 * Parse and build target attribute for links.
		 * @param string $value (_self, _blank, _windowopen, _modal)
		 * _blank 	Opens the linked document in a new window or tab
		 * _self 	Opens the linked document in the same frame as it was clicked (this is default)
		 * _parent 	Opens the linked document in the parent frame
		 * _top 	Opens the linked document in the full body of the window
		 * _windowopen  Opens the linked document in a Window
		 * _modal		Opens the linked document in a Modal Window
		 */
		public static function parseTarget($type='_self'){
			$target = '';
			switch($type){
				default:
				case '_self':
					break;
				case '_blank':
				case '_parent':
				case '_top':
					$target = 'target="'.$type.'"';
					break;
				case '_windowopen':
					$target = "onclick=\"window.open(this.href,'targetWindow','toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,false');return false;\"";
					break;
				case '_modal':
					// user process
					break;
			}
			return $target;
		}

		/**
		 * Truncate string by $length
		 * @param string $string
		 * @param int $length
		 * @param string $etc
		 * @return string
		 */
		public static function truncate($string, $length, $etc='...'){
		
			return defined('MB_OVERLOAD_STRING')
			? self::_mb_truncate($string, $length, $etc)
			: self::_truncate($string, $length, $etc);
		}

		/**
		 * Truncate string if it's size over $length
		 * @param string $string
		 * @param int $length
		 * @param string $etc
		 * @return string
		 */
		private static function _truncate($string, $length, $etc='...'){
			if ($length>0 && $length<strlen($string)){
				$buffer = '';
				$buffer_length = 0;
				$parts = preg_split('/(<[^>]*>)/', $string, -1, PREG_SPLIT_DELIM_CAPTURE);
				$self_closing_tag = split(',', 'area,base,basefont,br,col,frame,hr,img,input,isindex,link,meta,param,embed');
				$open = array();

				foreach($parts as $i => $s){
					if( false===strpos($s, '<') ){
						$s_length = strlen($s);
						if ($buffer_length + $s_length < $length){
							$buffer .= $s;
							$buffer_length += $s_length;
						} else if ($buffer_length + $s_length == $length) {
							if ( !empty($etc) ){
								$buffer .= ($s[$s_length - 1]==' ') ? $etc : " $etc";
							}
							break;
						} else {
							$words = preg_split('/([^\s]*)/', $s, - 1, PREG_SPLIT_DELIM_CAPTURE);
							$space_end = false;
							foreach ($words as $w){
								if ($w_length = strlen($w)){
									if ($buffer_length + $w_length < $length){
										$buffer .= $w;
										$buffer_length += $w_length;
										$space_end = (trim($w) == '');
									} else {
										if ( !empty($etc) ){
											$more = $space_end ? $etc : " $etc";
											$buffer .= $more;
											$buffer_length += strlen($more);
										}
										break;
									}
								}
							}
							break;
						}
					} else {
						preg_match('/^<([\/]?\s?)([a-zA-Z0-9]+)\s?[^>]*>$/', $s, $m);
						//$tagclose = isset($m[1]) && trim($m[1])=='/';
						if (empty($m[1]) && isset($m[2]) && !in_array($m[2], $self_closing_tag)){
							array_push($open, $m[2]);
						} else if (trim($m[1])=='/') {
							$tag = array_pop($open);
							if ($tag != $m[2]){
								// uncomment to to check invalid html string.
								// die('invalid close tag: '. $s);
							}
						}
						$buffer .= $s;
					}
				}
				// close tag openned.
				while(count($open)>0){
					$tag = array_pop($open);
					$buffer .= "</$tag>";
				}
				return $buffer;
			}
			return $string;
		}

		/**
		 * Truncate mutibyte string if it's size over $length
		 * @param string $string
		 * @param int $length
		 * @param string $etc
		 * @return string
		 */
		private static function _mb_truncate($string, $length, $etc='...'){
			$encoding = mb_detect_encoding($string);
			if ($length>0 && $length<mb_strlen($string, $encoding)){
				$buffer = '';
				$buffer_length = 0;
				$parts = preg_split('/(<[^>]*>)/', $string, -1, PREG_SPLIT_DELIM_CAPTURE);
				$self_closing_tag = explode(',', 'area,base,basefont,br,col,frame,hr,img,input,isindex,link,meta,param,embed');
				$open = array();

				foreach($parts as $i => $s){
					if (false === mb_strpos($s, '<')){
						$s_length = mb_strlen($s, $encoding);
						if ($buffer_length + $s_length < $length){
							$buffer .= $s;
							$buffer_length += $s_length;
						} else if ($buffer_length + $s_length == $length) {
							if ( !empty($etc) ){
								$buffer .= ($s[$s_length - 1]==' ') ? $etc : " $etc";
							}
							break;
						} else {
							$words = preg_split('/([^\s]*)/', $s, -1, PREG_SPLIT_DELIM_CAPTURE);
							$space_end = false;
							foreach ($words as $w){
								if ($w_length = mb_strlen($w, $encoding)){
									if ($buffer_length + $w_length < $length){
										$buffer .= $w;
										$buffer_length += $w_length;
										$space_end = (trim($w) == '');
									} else {
										if ( !empty($etc) ){
											$more = $space_end ? $etc : " $etc";
											$buffer .= $more;
											$buffer_length += mb_strlen($more);
										}
										break;
									}
								}
							}
							break;
						}
					} else {
						preg_match('/^<([\/]?\s?)([a-zA-Z0-9]+)\s?[^>]*>$/', $s, $m);
						//$tagclose = isset($m[1]) && trim($m[1])=='/';
						if (empty($m[1]) && isset($m[2]) && !in_array($m[2], $self_closing_tag)){
							array_push($open, $m[2]);
						} else if (trim($m[1])=='/') {
							$tag = array_pop($open);
							if ($tag != $m[2]){
								// uncomment to to check invalid html string.
								// die('invalid close tag: '. $s);
							}
						}
						$buffer .= $s;
					}
				}
				// close tag openned.
				while(count($open)>0){
					$tag = array_pop($open);
					$buffer .= "</$tag>";
				}
				return $buffer;
			}
			return $string;
		}
		
		public static function getInstance(){
			if (is_null(self::$helper)){
				$classname = __CLASS__;
				self::$helper = new $classname();
			}
			return self::$helper;
		}

	}
}
